# DO NOT MODIFY -- This file is generated by type_spec
# flake8: noqa: F821
# ruff: noqa: E402 Q003
# fmt: off
# isort: skip_file
from __future__ import annotations
import typing  # noqa: F401
import datetime  # noqa: F401
from decimal import Decimal  # noqa: F401
from pkgs.strenum_compat import StrEnum
import dataclasses
from pkgs.serialization import serial_class
from pkgs.serialization import serial_union_annotation
from . import identifier_t

__all__: list[str] = [
    "GenericRemoteDirectoryScope",
    "GenericUploadStrategy",
    "UploadDestination",
    "UploadDestinationBase",
    "UploadDestinationMaterialFamily",
    "UploadDestinationProject",
    "UploadDestinationRecipe",
    "UploadDestinationType",
]


# DO NOT MODIFY -- This file is generated by type_spec
@dataclasses.dataclass(kw_only=True)
class GenericRemoteDirectoryScope:
    src_path: str
    success_archive_path: str
    failure_archive_path: str
    recursive: bool
    prepend_date_on_archive: bool
    valid_file_extensions: list[str]
    filename_regex: typing.Optional[str] = None
    max_files: typing.Optional[int] = None
    detection_keyword: typing.Optional[str] = None
    delimiter: typing.Optional[str] = None


# DO NOT MODIFY -- This file is generated by type_spec
class UploadDestinationType(StrEnum):
    PROJECT = "project"
    MATERIAL_FAMILY = "material_family"
    RECIPE = "recipe"


# DO NOT MODIFY -- This file is generated by type_spec
@dataclasses.dataclass(kw_only=True)
class UploadDestinationBase:
    type: UploadDestinationType


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class UploadDestinationProject(UploadDestinationBase):
    type: typing.Literal[UploadDestinationType.PROJECT] = UploadDestinationType.PROJECT
    project_key: identifier_t.IdentifierKey


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class UploadDestinationMaterialFamily(UploadDestinationBase):
    type: typing.Literal[UploadDestinationType.MATERIAL_FAMILY] = UploadDestinationType.MATERIAL_FAMILY
    material_family_key: identifier_t.IdentifierKey


# DO NOT MODIFY -- This file is generated by type_spec
@serial_class(
    parse_require={"type"},
)
@dataclasses.dataclass(kw_only=True)
class UploadDestinationRecipe(UploadDestinationBase):
    type: typing.Literal[UploadDestinationType.RECIPE] = UploadDestinationType.RECIPE
    recipe_key: identifier_t.IdentifierKey


# DO NOT MODIFY -- This file is generated by type_spec
UploadDestination = typing.Annotated[
    typing.Union[UploadDestinationProject, UploadDestinationMaterialFamily, UploadDestinationRecipe],
    serial_union_annotation(
        discriminator="type",
        discriminator_map={
            "project": UploadDestinationProject,
            "material_family": UploadDestinationMaterialFamily,
            "recipe": UploadDestinationRecipe,
        },
    ),
]


# DO NOT MODIFY -- This file is generated by type_spec
@dataclasses.dataclass(kw_only=True)
class GenericUploadStrategy:
    uploader_key: identifier_t.IdentifierKey
    destinations: list[UploadDestination]
    skip_moving_files: bool = False
# DO NOT MODIFY -- This file is generated by type_spec
